# ======================================================================================================================
# Global
# ======================================================================================================================
stages:
  - build
  - static analysis
  - test
  - report
  - release
  - deploy

default:
  image: registry.gitlab.com/dependabot-gitlab/ci-images:ruby
  interruptible: true

variables:
  # App tags
  CURRENT_TAG: ${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}
  # Docker images
  APP_IMAGE: ${CI_REGISTRY_IMAGE}/dev:${CURRENT_TAG}
  MOCK_IMAGE: thiht/smocker:0.18.0
  QEMU_IMAGE: tonistiigi/binfmt:qemu-v7.0.0
  # Misc
  CODACY_VERSION: "13.10.7"
  DEPENDENCY_SCANNING_DISABLED: "true"
  SAST_DISABLED: "true"
  CODE_QUALITY_DISABLED: "true"
  LICENSE_MANAGEMENT_DISABLED: "true"
  BUILD_PLATFORM: linux/amd64,linux/arm64

include:
  - local: .gitlab/ci/jobs.gitlab-ci.yml
  - local: .gitlab/ci/rules.gitlab-ci.yml

# ======================================================================================================================
# Pre Stage
# ======================================================================================================================
dont-interrupt:
  extends:
    - .dont-interrupt
    - .rules:dont-interrupt

cache-dependencies:
  extends:
    - .rules:main
    - .cache_dependencies

# ======================================================================================================================
# Build Stage
# ======================================================================================================================
build-core-image:
  extends:
    - .build_core_image
    - .rules:build-core-image

build-app-image:
  extends:
    - .build_app_image
    - .rules:build-image
  needs:
    - job: build-core-image
      optional: true

build-docs:
  extends:
    - .build_docs
    - .rules:build-docs

# ======================================================================================================================
# Static analysis stage
# ======================================================================================================================
rubocop:
  extends:
    - .rubocop
    - .rules:main
  needs:
    - cache-dependencies

reek:
  extends:
    - .reek
    - .rules:main
  needs:
    - cache-dependencies

brakeman:
  extends:
    - .brakeman
    - .rules:main
  needs: []

dependency-scan:
  extends:
    - .dependency_scan
    - .rules:dependency-scan
  needs: []

license-scan:
  extends:
    - .license_scan
    - .rules:license-scan
  needs: []

container-scan:
  extends:
    - .container_scan
    - .rules:container-scan
  needs:
    - cache-dependencies
    - build-app-image

# ======================================================================================================================
# Test Stage
# ======================================================================================================================
unit-test:
  extends:
    - .unit-test
    - .rules:main
  needs:
    - cache-dependencies

system-test:
  extends:
    - .system-test
    - .rules:main
  needs:
    - cache-dependencies

standalone-test:
  extends:
    - .standalone-test
    - .rules:main
  needs:
    - build-app-image

deploy-test:
  extends:
    - .deploy-test
    - .rules:main
  needs:
    - build-app-image

migration-test:
  extends:
    - .migration-test
    - .rules:migration-test
  needs:
    - build-app-image

# ======================================================================================================================
# Reporting
# ======================================================================================================================
publish-allure-reports:
  extends:
    - .allure_report
    - .rules:allure-reports
  needs:
    - unit-test
    - system-test

publish-coverage:
  extends:
    - .coverage
    - .rules:coverage
  needs:
    - unit-test
    - system-test
    - cache-dependencies

# ======================================================================================================================
# Release Stage
# ======================================================================================================================
release-image:
  extends:
    - .release_image
    - .rules:release
  dependencies: []

create-gitlab-release:
  extends:
    - .gitlab_release
    - .rules:release
  needs: [release-image]

update-helm-chart:
  extends:
    - .update_chart
    - .rules:release
  needs: [release-image]

update-standalone-repo:
  extends:
    - .update_standalone
    - .rules:release
  needs: [release-image]

pages:
  extends:
    - .publish_docs
    - .rules:release-docs
  dependencies: [build-docs]

# ======================================================================================================================
# Deploy Stage
# ======================================================================================================================
deploy:
  extends:
    - .deploy
    - .rules:deploy
